#include "defextern.h"

#include <stdio.h>
#include <windows.h>
#include <iostream.h>
#include <fstream.h>
#include "resource.h"
#include "file.h"
#include "scroll.h"
#include "tabasa_recorder.h"
#include "wavepic.h"
#include "wavepitch.h"
#include "language.h"
#include "SoundBuffer.h"
#include "WaveEditOnPlaying.h"
#include "thread.h"
#include "spectrum.h"
#include "init.h"
#include "recOptionDlg.h"
#include "position.h"
#include "waveform.h"
#include "FileSave.h"

#define END_OK "ok" //I
#define START_OK "start" //
#define recordsizedefault 2000000000//

void writefilename(char *file,char *initfname)
{
	WritePrivateProfileString("init", "file", file, initfname);
}

//-----------------------------------------------------------------------
//	

void initialize(ifstream &init,char *initfname)
{
	char name[MAX_PATH],ans[MAX_PATH+1];
	WAVEFORMATEX waveform;
	sprintf(filename,"record.wav");
	sprintf(buffname,"tabasa_record.wav");
	initpositionfile();

	cutpercent =50;
	waveshot =waveshotdefault;
	raterate=ratedefault;
	rate=ratebase*raterate;
	octavenow =0;
	channels=STEREO;
	format=WAVE_FORMAT_PCM;
	datasize=16000;
	effectfilenum=0;
	langflag=LANG_JP;
	SetLang(langflag);
	nextzero=skipleveldefault;
	addmode=_ADD;
	samplesize=samplesizeA;
	playsamplesize=samplesize;
	recordsizemax =recordsizedefault;

	int limit =GetPrivateProfileInt("init","limitmega",0,initfname);
	if(limit>0) recordsizemax = limit*1000000;
	GetPrivateProfileString("init", "endstatus", "", ans, MAX_PATH, initfname);
	if(strcmp(ans,END_OK)!=0)
	{
		GetPrivateProfileString("init", "file", "record.wav", filename, MAX_PATH, initfname);
		setwaveformRec(waveform,format,channels,rate,playsamplesize);
		saveall(waveform,filename,0);
	}
	WritePrivateProfileString("init", "endstatus", START_OK, initfname);

	initwavepic();
	initwavepicx();

	strcpy(thisname,_version);
	GetPrivateProfileString("init", "file", filename, name, MAX_PATH, initfname);

	//init>>name;
	//if(init.gcount()>0)sprintf(filename,"%s",name);

	bTerminating =FALSE;
	piconrecflag =FALSE;
	picflagreset();
	pitchflag =TRUE;
	seqplayflag=FALSE;
	RecStandBy=FALSE;
	looprecflag=FALSE;
	feedbackflag=FALSE;
	specflag=FALSE;
	threadflag=FALSE;
	threadendflag=FALSE;
	autoplayflag=FALSE;
	play16bitflag =FALSE;
	recmode=_HDD;

	writingnum=0;
	editoffset=0;
	positionnow = 0 ;
	startpositionnow = 0 ;
	endpositionnow = 0 ;
	flagrepeat = 1;
	minimumlenInit();//editminimumlen=65536/16;
	looprecsize =LOOPRECSIZE;

	
	//ou.setbuf(NULL,0);// obt@OȂH

	return;
}

//-----------------------------------------------------------------------
//	

void ondestroy(char *initial)
{
	WritePrivateProfileString("init", "endstatus", END_OK, initial);
	//ofstream init(initial);
	//writeinit(init);
}
//-----------------------------------------------------------------------
//	

void writeinit(ofstream &init)
{
	return;
}
			  
void FncCommandline(char* commandline,BOOL& play,char* pathname)
{	
	int i=0;
	play=FALSE;

	if(commandline[i]=='/')
	{
		i++;
		if(commandline[i]=='p'||commandline[i]=='P')
		{
			i++;
			play=TRUE;
		}
	}
	while(commandline[i]==' '||commandline[i]=='\t')i++;

	for(int j=0;i<strlen(commandline);i++)
		if(commandline[i]!='\"')//Ƃ@肻
		{
			pathname[j]=commandline[i];
			j++;
		}
}

