
//---------------------------------------------------------
//	option setting dialog 

#include "defextern.h"

#include <stdio.h>
#include <iostream.h>
#include <fstream.h>
#include <windows.h>
#include <vfw.h>

#include "resource.h"
#include "tabasa_recorder.h"
#include "MainDlg.h"
#include "scroll.h"
#include "recOptionDlg.h"
#include "language.h"
#include "WaveEditOnPlaying.h"
#include "SoundBuffer.h"
#include "wavepic.h"


static char DlgTitle[]="record option";
HWND hwndRecVolume,hwndSkiplevel;
#define idRecVOLUME 1
#define idSkiplevel 2
HMIXER hmx=NULL;
MIXERLINE mxl;
UINT nDevId=0;

char recmodetxt[][4]={"mem","HDD"};

void setRecVolume(HWND hwnd,float recVolume)
{
//	level = levelp;
	settext(hwnd,IDC_EDIT_recvolume,recVolume*50,"");
	SetScrollPos  (hwndRecVolume, SB_CTL, max(0,min(volumemax*100,recVolume*volumemax*50)), TRUE) ;
}

void recVolumeScrollinit(HWND hwnd)
{
	YokoScrollinit(hwnd,hwndRecVolume,idRecVOLUME,40,40,recVolumesize.x,recVolumesize.y,volumemax*100);
	setRecVolume(hwnd,recVolume*volumemax*50) ;

}

void setSkiplevel(HWND hwnd,float recVolume)
{
//	level = levelp;
	settext(hwnd,IDC_EDIT_skiplevel,nextzero,"");
	SetScrollPos  (hwndSkiplevel, SB_CTL, max(0,min(skiplevelmax,nextzero)), TRUE) ;
}

void skiplevelScrollinit(HWND hwnd)
{
	YokoScrollinit(hwnd,hwndSkiplevel,idSkiplevel,40,460,recVolumesize.x,recVolumesize.y,skiplevelmax);
	setSkiplevel(hwnd,nextzero) ;

}

BOOL CALLBACK recOptionProc (HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	static char buff[MAX_PATH];
	static int nownum,auxNum,waveinNum;
     switch (message)
     {
		case WM_INITDIALOG:
			SetWindowText(hwnd,DlgTitle);
			recVolumeScrollinit(hwnd);
			skiplevelScrollinit(hwnd);
			setRecVolume(hwnd,recVolume);
			setSkiplevel(hwnd,nextzero);
			waveinNum=auxGetNumDevs();
			  sprintf(buff,"%d",waveinNum);
			  SetDlgItemText(hwnd,IDC_CHANGE_rec_mode,recmodetxt[recmode]);
			  SetDlgItemText(hwnd,IDC_EDIT_AUX_NUM,buff);
			  SetDlgItemInt(hwnd,IDC_looprecsize,looprecsize,FALSE);
			  SetDlgItemInt(hwnd,IDC_EDIT_showrate_x,wavepicshowratex*100,FALSE);
			  SetDlgItemInt(hwnd,IDC_EDIT_showrate_y,wavepicshowrate*100,FALSE);
			  SendMessage (hwnd, WM_COMMAND, IDC_SHOW_add_mode,lParam) ;
			break;

     case WM_HSCROLL :
          if((HWND) lParam==hwndSkiplevel)
		  {
				scrollfnc(wParam,nextzero,skiplevelmax);
				setSkiplevel(hwnd,nextzero);
		  }
          if((HWND) lParam==hwndRecVolume)
		  {
				volumescrollfnc(wParam,recVolume,volumemax);
				setRecVolume(hwnd,recVolume);
		  }
		  break;

     case WM_COMMAND:
          switch (LOWORD (wParam))
          {//
          case IDC_PLAY_recvolumereset:
                    // ad Reverb save buffer
			  recVolume=volumeDefault;
               setRecVolume(hwnd,recVolume);
               return TRUE ;

          case IDC_PLAY_skiplevelreset:
			  nextzero=skipleveldefault;
               setSkiplevel(hwnd,nextzero);
               return TRUE ;

		  case IDC_noiseoff_len_down:
			  noiseofflendown();
			  SetDlgItemInt(hwnd,IDC_EDIT_noiseofflen,noiseofflen,FALSE);
			  break;

		  case IDC_noiseoff_len_up:
			  noiseofflenup();
			  SetDlgItemInt(hwnd,IDC_EDIT_noiseofflen,noiseofflen,FALSE);
			  break;

		  case IDC_noiseoff_len_reset:
			  noiseofflenreset();
			  SetDlgItemInt(hwnd,IDC_EDIT_noiseofflen,noiseofflen,FALSE);
			  break;

		  case IDC_minimumlen_reset:
			  editminimumlen.reset();
			  SetDlgItemInt(hwnd,IDC_EDIT_minimumlen,editminimumlen.getdata(),FALSE);
			  break;

		  case IDC_minimumlen_up:
			  editminimumlen.up();
			  SetDlgItemInt(hwnd,IDC_EDIT_minimumlen,editminimumlen.getdata(),FALSE);
			  break;

		  case IDC_minimumlen_down:
			  editminimumlen.down();
			  SetDlgItemInt(hwnd,IDC_EDIT_minimumlen,editminimumlen.getdata(),FALSE);
			  break;

		  case IDC_wavepic_x_showrate_1:
		  case IDC_wavepic_x_showrate_down:
		  case IDC_wavepic_x_showrate_up:
		  case IDC_wavepic_showrate_1:
		  case IDC_wavepic_showrate_down:
		  case IDC_wavepic_showrate_up:
		  case IDC_CHANGE_WAVE:
			  SendMessage (mainhwnd, WM_COMMAND, wParam,lParam) ;
			  SetDlgItemInt(hwnd,IDC_EDIT_showrate_x,wavepicshowratex*100,FALSE);
			  SetDlgItemInt(hwnd,IDC_EDIT_showrate_y,wavepicshowrate*100,FALSE);
			  break;


		  case IDC_CHANGE_SHOW_MODE:
			  specflag =!specflag;
			  break;

		  case IDC_CHANGE_add_mode:
			  if(addmode == _ADD ) 
			  {
				  addmode=_TIMES ;
			  }
			  else 
			  {
				  addmode=_ADD;
			  }
			  SendMessage (hwnd, WM_COMMAND, IDC_SHOW_add_mode,lParam) ;
			  break;


		  case IDC_SHOW_add_mode:
			  if(addmode == _ADD ) 
			  {
				  SetDlgItemText(hwnd,IDC_EDIT_addmode,"add");
			  }
			  else 
			  {
				  SetDlgItemText(hwnd,IDC_EDIT_addmode,"times");
			  }
			  break;

		  case IDC_CHANGE_LANG:
			  ChangeLang();
			  break;

		  case IDC_CHANGE_rec_mode:
			  if(recmode==_MEM) recmode=_HDD;
			  else recmode=_MEM;
			  SetDlgItemText(hwnd,IDC_CHANGE_rec_mode,recmodetxt[recmode]);
			  break;

		  case IDC_CHANGE_WAVE_L:
			  Lpicflag =!Lpicflag;
			  break;

		  case IDC_CHANGE_WAVE_R:
			  Rpicflag =!Rpicflag;
			  break;

		  case IDC_looprecsize:
			  GetDlgItemText(hwnd,IDC_looprecsize,buff,MAX_PATH);
			  sscanf(buff,"%d",&looprecsize);
			  if(looprecsize<LOOPRECSIZEMIN) looprecsize =LOOPRECSIZEMIN;
			  SetDlgItemInt(hwnd,IDC_looprecsize_min,looprecsize/(playsamplesize/8*channels*rate)/60,FALSE);
			  break;

		  case IDC_REC_FOREVER:
			  GetDlgItemText(hwnd,IDC_looprecsize,buff,MAX_PATH);
			  sscanf(buff,"%d",&looprecsize);
			  if(looprecsize<LOOPRECSIZEMIN) looprecsize =LOOPRECSIZEMIN;
				SendMessage (mainhwnd, WM_COMMAND, wParam,lParam) ;
               SendMessage (hwnd, WM_SYSCOMMAND, SC_CLOSE, 0L) ;
			  break;

		  case IDC_REPAIR_SOUND:
			  GetDlgItemText(hwnd,IDC_sound_jump_max,buff,MAX_PATH);
			  sscanf(buff,"%d",&SoundJumpMax);
			  if(SoundJumpMax<SoundJumpMaxMin) SoundJumpMax=SoundJumpMaxMin;
				SendMessage (mainhwnd, WM_COMMAND, wParam,lParam) ;
               SendMessage (hwnd, WM_SYSCOMMAND, SC_CLOSE, 0L) ;
			  break;

          case IDOK:
          case IDCANCEL:
               SendMessage (hwnd, WM_SYSCOMMAND, SC_CLOSE, 0L) ;
               return TRUE ;


		  }
		  break;

		case WM_SYSCOMMAND:
			switch (LOWORD (wParam))
			{
				case SC_CLOSE:
					EndDialog (hwnd, 0) ;
				return TRUE ;
			}
			break ;
          
	}
	 return FALSE;
}
