
#include "defextern.h"

#include <stdio.h>
#include <iostream.h>
#include <fstream.h>
#include <windows.h>
#include "resource.h"
#include "tabasa_recorder.h"
#include "SoundBuffer.h"
#include "MainDlg.h"
#include "scroll.h"
#include "wav8bit.h"
#include "wavepitch.h"
#include "wavepic.h"
#include "waveform.h"
#include "time.h"


ULONG scrollmin;

void scrollinit()
{
	level=levelDefault;
	volume=volumeDefault;
	recVolume=volumeDefault;
	speedr=speedDefault;
	speed = speedr * speedr;
	pitch=pitchDefault;
	volumeright=100;
	volumeleft=100;
	int scroll_interval=63;
	scrollmin=12;

	boostp.x=270+30-10;
	boostp.y=300+38;
	boostsize.x=117+95;
	boostsize.y=10;
	volumep.x=boostp.x;
	volumep.y=boostp.y+scroll_interval;
	speedp.x=boostp.x;
	speedp.y=boostp.y-scroll_interval;
	pitchp.x=boostp.x;
	pitchp.y=boostp.y-scroll_interval*2;
	panp.x=boostp.x;
	panp.y=boostp.y-scroll_interval*3;
	volumesize = speedsize = pitchsize =boostsize;
	recVolumesize.x=volumesize.x;
	recVolumesize.y=volumesize.y;

	volume100max=bit16max;
	volmeterx=450;
	volmetery=400;
	levelp=levelDefault;

	reverbsize=reverbsizeDefault;//
	startplacemax=1000;
	startplacenow=0;
	startplace=0;


	endplacemax=1000;
	endplacenow=1000;
	endplace=1000;

	scrollmax=1000;
	scrollnow=1000;
	scrollp=0;

	playscrollinit();
	startscrollinit();
	endscrollinit();
	boostscrollinit();
	volumescrollinit();
	speedscrollinit();
	pitchscrollinit();
	panscrollinit();
}

//........................................
//	volumef[^Zbg

void setvolume100(char *wavenow)
{
		 sscanf(wavenow,"%d",&volume100);
		 volume100=100*abs(volume100)/volume100max;
}

void setvolume100max(int samplesize)
{
          if(samplesize==16) volume100max=bit16max;
		  else  volume100max=bit8mid;
}

void setspeed(float speed)
{
//	speed = speedp;
	speed=min(speedmax,max(speedmin,speed));
	settext(IDC_EDIT_speed,speed*100,"");
	SetScrollPos  (hwndSpeed, SB_CTL, max(100,min(speedmax*90,speed*500)), TRUE) ;
}

void setpitch(float pitch)
{
//	speed = speedp;
	pitch=min(pitchmax,max(pitchmin,pitch));
	settext(IDC_EDIT_pitch,pitch*100,"");
	SetScrollPos  (hwndPitch, SB_CTL, max(100,min(pitchmax*90,pitch*500)), TRUE) ;
}

void setboost(float levelp)
{
	level = levelp;
	settext(IDC_EDIT_boost,level*100,"");
	SetScrollPos  (hwndBoost, SB_CTL, max(100,min(levelmax*90,level*500)), TRUE) ;
}

void setwaveedit(HWND &hwnd,HWND &hwndw,long value)
{
	settext(hwnd,IDC_EDIT_WAVE,value,"");
	SetScrollPos  (hwndw, SB_CTL, value, TRUE) ;
}

void setboost(HWND &hwnd,HWND &hwndb,UINT id,float boostlevel)
{
	settext(hwnd,id,boostlevel*100,"");
	SetScrollPos  (hwndb, SB_CTL, max(100,min(levelmax*90,boostlevel*500)), TRUE) ;
}

void setPan(HWND &hwnd,HWND &hwndb,UINT id,float panlevel)
{
	settext(hwnd,id,panlevel,"");
	SetScrollPos  (hwndb, SB_CTL, max(-panmax,min(panmax,panlevel)), TRUE) ;
}

void setvolume(float volume)
{
//	level = levelp;
	settext(IDC_EDIT_volume,volume*50,"");
	SetScrollPos  (hwndVolume, SB_CTL, max(0,min(volumemax*100,volume*volumemax*50)), TRUE) ;
}

void waveeditscrollfnc(WPARAM wParam,long &value,long max)
{
	int step=100;
          switch (LOWORD (wParam))
          {
          case SB_PAGEDOWN :
               value +=  step;
                                             // fall through
          case SB_LINEDOWN :
               value = min (max, value + 1) ;
               break ;
               
          case SB_PAGEUP :
               value -= step ;
                                             // fall through
          case SB_LINEUP :
               value = max (-max, value - 1) ;
               break ;
               
          case SB_TOP :
               value = 0 ;
               break ;
               
          case SB_BOTTOM :
               value = max ;
               break ;

		case SB_THUMBTRACK :
               value = HIWORD (wParam) ;
               break ;
               

          default :
               break ;
          }
}

void boostscrollfnc(WPARAM wParam,float &value,float max)
{
          switch (LOWORD (wParam))
          {
          case SB_PAGEDOWN :
               value += levelplus*5 ;
                                             // fall through
          case SB_LINEDOWN :
               value = min (max, value + levelplus) ;
               break ;
               
          case SB_PAGEUP :
               value -= levelplus*5 ;
                                             // fall through
          case SB_LINEUP :
               value = max (-max, value - levelplus) ;
               break ;
               
          case SB_TOP :
               value = 0 ;
               break ;
               
          case SB_BOTTOM :
               value = max ;
               break ;

		case SB_THUMBTRACK :
               value = HIWORD (wParam)/500.0 ;
               break ;
               

          default :
               break ;
          }
}

void panscrollfnc(WPARAM wParam,float &value,float min,float max)
{
//	lastvalue=value;
          switch (LOWORD (wParam))
          {
          case SB_PAGEDOWN :
               value += panplus*5 ;
                                             // fall through
          case SB_LINEDOWN :
               value = min (max, value + panplus) ;
               break ;
               
          case SB_PAGEUP :
               value -= panplus*5 ;
                                             // fall through
          case SB_LINEUP :
               value = max (-max, value - panplus) ;
               break ;
               
          case SB_TOP :
               value = min ;
               break ;
               
          case SB_BOTTOM :
               value = max ;
               break ;

		case SB_THUMBTRACK :
               value = (short)(HIWORD (wParam)) ;
               break ;
               

          default :
               break ;
          }
}

void volumescrollfnc(WPARAM wParam,float &value,float max)
{
          switch (LOWORD (wParam))
          {
          case SB_PAGEDOWN :
               value += levelplus*5 ;
                                             // fall through
          case SB_LINEDOWN :
               value = min (max, value + levelplus) ;
               break ;
               
          case SB_PAGEUP :
               value -= levelplus*5 ;
                                             // fall through
          case SB_LINEUP :
               value = max (0, value - levelplus) ;
               break ;
               
          case SB_TOP :
               value = 0 ;
               break ;
               
          case SB_BOTTOM :
               value = max ;
               break ;

		case SB_THUMBTRACK :
               value = HIWORD (wParam)/(max*50) ;
               break ;
               

          default :
               break ;
          }
}

void scrollminset()
{
	scrollmin =(ULONG)(min(44100,max((rate/48)/wavepicshowratex,16))/12)*12;//posstepmin*6
}

ULONG getscrollmin()
{
	return scrollmin;
}

void scrollfnc(WPARAM wParam,long &scrollp,long scrollmax,ULONG &pos)
{
	switch (LOWORD (wParam))
          {
          case SB_LINEDOWN :
               pos+=scrollmin ;
			   scrollp=(float)pos/datasize*scrollmax;
               break ;
                             // fall through
          case SB_LINEUP :
               if(pos>=posstepmin)
			   {
				   pos-=scrollmin ;
				   scrollp=(float)pos/datasize*scrollmax;
			   }
               break ;
               
          case SB_PAGEDOWN :
               scrollp += 16 ;
			  pos=datasize/scrollmax*scrollp/12*12;
                                             // fall through
               break ;
               
          case SB_PAGEUP :
               scrollp -= 16 ;
			  pos=datasize/scrollmax*scrollp/12*12;
                                             // fall through
               break ;
               
          case SB_TOP :
               scrollp = 1 ;
			  pos=datasize/scrollmax*scrollp/12*12;
               break ;
               
          case SB_BOTTOM :
               scrollp = scrollmax ;
			  pos=datasize/scrollmax*scrollp/12*12;
               break ;

		case SB_THUMBTRACK :
               scrollp = HIWORD (wParam) ;
			  pos=datasize/scrollmax*scrollp/12*12;
               break ;



          default :
			  //scrollfnc(wParam,scrollp,scrollmax);
               break ;
          }
}

void scrollfnc(WPARAM wParam,long &scrollp,long scrollmax)
{
          switch (LOWORD (wParam))
          {
          case SB_PAGEDOWN :
               scrollp += 16 ;
                                             // fall through
          case SB_LINEDOWN :
               scrollp = min (scrollmax, scrollp + 1) ;
               break ;
               
          case SB_PAGEUP :
               scrollp -= 16 ;
                                             // fall through
          case SB_LINEUP :
               scrollp = max (1, scrollp - 1) ;
               break ;
               
          case SB_TOP :
               scrollp = 1 ;
               break ;
               
          case SB_BOTTOM :
               scrollp = scrollmax ;
               break ;

		case SB_THUMBTRACK :
               scrollp = HIWORD (wParam) ;
               break ;

          default :
               break ;
          }
}


void scrollinit(int tate,HWND &mainhwnd,HWND &hwnd,int ID,int x1,int y1,int x2,int y2,long min,long max)
{
	hwnd = CreateWindow (TEXT ("scrollbar"), NULL,
							WS_CHILD | WS_VISIBLE | 
							WS_TABSTOP | tate,
							x1,y1,
							x2,y2,
							 mainhwnd, (HMENU) ID, NULL, NULL) ;//(HINSTANCE) GetWindowLong (hwnd, GWL_HINSTANCE)
               
	SetScrollRange (hwnd, SB_CTL, min, max, TRUE) ;

}

void scrollinit(int tate,HWND &mainhwnd,HWND &hwnd,int ID,int x1,int y1,int x2,int y2,long max)
{
	scrollinit(tate,mainhwnd,hwnd,ID,x1,y1,x2, y2,1,max);
}

void YokoScrollinit(HWND &mainhwnd,HWND &hwnd,int ID,int x1,int y1,int x2,int y2,long max)
{
	scrollinit(SBS_HORZ,mainhwnd,hwnd,ID,x1,y1,x2,y2,max);
}

void YokoScrollinit(HWND &mainhwnd,HWND &hwnd,int ID,int x1,int y1,int x2,int y2,long min,long max)
{
	scrollinit(SBS_HORZ,mainhwnd,hwnd,ID,x1,y1,x2,y2,min,max);
}

void TateScrollinit(HWND &mainhwnd,HWND &hwnd,int ID,int x1,int y1,int x2,int y2,long max)
{
	scrollinit(SBS_VERT|SBS_BOTTOMALIGN,mainhwnd,hwnd,ID,x1,y1,x2,y2,max);
}

void playscrollinit()
{
	YokoScrollinit(mainhwnd,hwndScroll,idSCROLL,16,200,227,10,scrollmax);
	SetScrollPos   (hwndScroll, SB_CTL, 1, TRUE) ;
}

void startscrollinit()
{
	YokoScrollinit(mainhwnd,hwndStartPlace,idSCROLL,16,200+20,227,10,startplacemax);
	SetScrollPos   (hwndStartPlace, SB_CTL, 1, TRUE) ;
}

void endscrollinit()
{
	YokoScrollinit(mainhwnd,hwndEndPlace,idSCROLL,16,200+20*2,227,10,endplacemax);
	SetScrollPos   (hwndEndPlace, SB_CTL, endplace, TRUE) ;
}

void panscrollinit(HWND &hwnd,HWND &hwndP,POINT pa,float &levelnow,float max)
{
	YokoScrollinit(hwnd,hwndP,idPAN,pa.x,pa.y,boostsize.x,boostsize.y,-max,max);
	SetScrollPos   (hwndP, SB_CTL, levelnow*levelmax*50, TRUE) ;
}

void panscrollinit()
{
	panscrollinit(mainhwnd,hwndPan,panp,pan,panmax);
}

void boostscrollinit(HWND &hwnd,HWND &hwndB,POINT vol,float &levelnow)
{
	YokoScrollinit(hwnd,hwndB,idVOLUME,vol.x,vol.y,boostsize.x,boostsize.y,levelmax*100);
	SetScrollPos   (hwndB, SB_CTL, levelnow*levelmax*50, TRUE) ;
}

void editinit(HWND &hwnd,HWND &hwndsub,int x,int y)
{
	hwndsub = CreateWindow(
		"edit",
		NULL,
		WS_CLIPCHILDREN | WS_CHILD | WS_BORDER,
		x,y,30,10,
		hwnd,
		NULL,
		NULL,
		NULL
	);
	ShowWindow(hwndsub,SW_SHOW);
/*
	OldWaveL = (WNDPROC) SetWindowLong (hwndwaveL, 
                                             GWL_WNDPROC, (LONG) WaveLProc) ;
											 */
}

void editscrollinit(HWND &hwnd,HWND &hwndB,POINT vol,long &value,long max=bit16umax,long min=0)
{
	static HWND hwnded;
	YokoScrollinit(hwnd,hwndB,idVOLUME,vol.x,vol.y,boostsize.x,boostsize.y,min,max);
	SetScrollPos   (hwndB, SB_CTL, value, TRUE) ;
	//editinit(hwnd,hwnded,vol.x+boostsize.x,vol.y);
}

void boostscrollinit()
{
	boostscrollinit(mainhwnd,hwndBoost,boostp,level);
}
/*
void volumescrollinit(HWND hwnd,HWND hwndV,POINT vol)
{
	YokoScrollinit(hwnd,hwndV,idVOLUME,vol.x,vol.y,volumesize.x,volumesize.y,volumemax*100);
	SetScrollPos   (hwndV, SB_CTL, volume*volumemax*50, TRUE) ;
}

void volumescrollinit(HWND hwnd)
{
	volumescrollinit(hwnd,hwndVolume,volumep) ;
}
*/
void volumescrollinit()
{
	YokoScrollinit(mainhwnd,hwndVolume,idVOLUME,volumep.x,volumep.y,volumesize.x,volumesize.y,volumemax*100);
	SetScrollPos   (hwndVolume, SB_CTL, volume*volumemax*50, TRUE) ;

}


void speedscrollinit()
{
	YokoScrollinit(mainhwnd,hwndSpeed,idSPEED,speedp.x,speedp.y,speedsize.x,speedsize.y,speedmax*100);
	//SetScrollPos   (hwndSpeed, SB_CTL, speed*speedmax*50, TRUE) ;
	setspeed(speed);
}


void pitchscrollinit()
{
	YokoScrollinit(mainhwnd,hwndPitch,idPITCH,pitchp.x,pitchp.y,pitchsize.x,pitchsize.y,pitchmax*100);
	//SetScrollPos   (hwndPitch, SB_CTL, pitch*pitchmax*50, TRUE) ;
	setpitch(pitch);
}


void commonscroll(WPARAM wParam,float &value,double valuemax,double valuemin,double valueplus)
{
          switch (LOWORD (wParam))
          {
          case SB_PAGEDOWN :
               value = min(valuemax,value+valueplus*4) ;
                                             // fall through
          case SB_LINEDOWN :
               value = min (valuemax, value + valueplus) ;
               break ;
               
          case SB_PAGEUP :
               value = max(valuemin,value-valueplus*4) ;
                                             // fall through
          case SB_LINEUP :
               value = max (valuemin, value - valueplus) ;
               break ;
               
          case SB_TOP :
               value = valuemin ;
               break ;
               
          case SB_BOTTOM :
               value = valuemax ;
               break ;

		case SB_THUMBTRACK :
               value = min(valuemax,max(valuemin,HIWORD (wParam)/500.0)) ;
               break ;
               

          default :
               break ;
          }
          //
}


void speedscroll(WPARAM wParam)
{
	commonscroll(wParam,speedr,speedrmax,speedrmin,speedrplus);
	speed =speedr *speedr;
}

void pitchscroll(WPARAM wParam)
{
	commonscroll(wParam,pitch,pitchmax,pitchmin,pitchplus);
}

BOOL DlgScrollMain(HWND lParam,WPARAM wParam, ifstream *in, HWAVEOUT &hWaveOut, time &now)
{
	char *buff =commandline;
	if((HWND) lParam==hwndScroll)
	{
		scrollfnc(wParam,scrollp,scrollmax,positionnow);
      //
		scrollnow = scrollp+1;
		//positionnow=datasize/scrollmax*scrollnow/4*4;
		SetScrollPos  (hwndScroll, SB_CTL, scrollnow, TRUE) ;
		if(bPlaying)
		{
			in->seekg(positionnow +datapos(),ios::beg);
			in->read(pSkipBuffer,def_buffersize);//g`\pɓǂݍ
			setpositionnow(in);
		}
		else
		{
			resetsoundpic();
		}
		Time(positionnow,BPSstep);
		pWavepicBuffer =pSkipBuffer;
		ShowWave();//g`\
	}
	if((HWND) lParam==hwndStartPlace)
	{
		scrollfnc(wParam,startplace,startplacemax);
      //
		startplacenow = startplace+1;
		startpositionnow=datasize/startplacemax*startplacenow/12*12;//
		SetScrollPos  (hwndStartPlace, SB_CTL, startplacenow, TRUE) ;
	}
	if((HWND) lParam==hwndEndPlace)
	{
		scrollfnc(wParam,endplace,endplacemax);
      //
		endplacenow = endplace+1;
		endpositionnow=datasize/endplacemax*endplacenow/12*12;
		SetScrollPos  (hwndEndPlace, SB_CTL, endplacenow, TRUE) ;
	}
       
     // InvalidateRect (hwnd, NULL, TRUE) ;
	if((HWND) lParam==hwndVolume)
	{
		volumescrollfnc(wParam,volume,volumemax);
      //
		setvolume(volume);
		setVolume(volumeright*volume/volumemax,volumeleft*volume/volumemax,hWaveOut);
	}
	
	if((HWND) lParam==hwndBoost)
	{
		boostscrollfnc( wParam,levelp,levelmax);
      //
		setboost(levelp);
	}
	if((HWND) lParam==hwndSpeed)
	{
		speedscroll(wParam);
		setspeed(speed);
		setreadbuffersize();
	}
	if((HWND) lParam==hwndPitch)
	{
		pitchscroll(wParam);
		setpitch(pitch);
		//setreadbuffersize();
		now.SetNow();
		sprintf(buff,"%06ld.%03d(%07ld) pitch %0.4f",now.GetPast(1),now.GetPast(2),now.GetInterval(),pitch);
		//if(seq.getRecording())seq.out<<buff<<endl;
		Commentseq(buff);
	}
	if((HWND) lParam==hwndPan)
	{
		//panscroll(wParam);
		//setpan(pan);
		panscrollfnc( wParam,w.getPan(),-panmax,panmax);
      //
		setPan(mainhwnd,hwndPan,IDC_EDIT_pan,w.getPan());
		seq.out.write("pan\n",4);
		//setreadbuffersize();
	}
	return TRUE;
}