
#ifndef _wavetrack
#define _wavetrack

#include <stdio.h>
#include "SoundFileIO.h"

const DWORD headersize=0x02c;

#define levelDefault 1
#define levelmax 10
#define levelmin 0.01
#define panmax 100

//E100,100
const float panLeft =-panmax;
const float panCenter =0;
const float panRight =panmax;

class Skip
{
	ULONG* start;
	ULONG* end;
	Skip *next;
public:
	Skip(){newstartend();next=NULL;setstart(0);setend(0);};
	Skip(ULONG s,ULONG e){newstartend();next=NULL;setstart(s);setend(e);};
	Skip(Skip& s){next=s.next;s.next = this;newstartend();setstart(0);setend(0);};
	Skip(Skip& s,ULONG st,ULONG e){next=s.next;s.next = this;newstartend();setstart(st);setend(e);};
	~Skip(){delete start;delete end;if(next!=NULL) delete next;};
	void newstartend(){
		start=new ULONG;end=new ULONG;};
	
	void setstart(ULONG s){*start=s;};
	void setend(ULONG e){*end=e;};
	ULONG *getstart(){return start;};
	ULONG *getend(){return end;};
	Skip *getnext(){return next;};
};


class SoundBase//:public	ifstream
{
	char name[MAX_PATH];	//t@C
	BOOL playing;	//t
	BOOL loaded;	//Ǎݍς݁i͊Jj
	BOOL recorded;
	BOOL ended;
	ULONG position;	//X^[gʒu
	ULONG positionnow;
	Skip *skipnow,*skip;
	ULONG skipnum;	//ۑꂽXLbvf[^̐
	ULONG skipnumnow;	//ݍĐʒu̎̃XLbvf[^
	float pan,lastpan;		//XeI̒
	float boost,lastboost;	//Đɒ萔{
	char header[headersize];	//wb_
public:
	ifstream in;	//t@CXg[
	SoundBase()
	{
		setpositionnow(0);
		setrecorded(FALSE);
		setplaying(FALSE);
		setloaded(FALSE);
		boost=levelDefault;
		lastboost=boost;
		resetPan();
		lastpan=pan;
		resetskip();
	};
	~SoundBase(){delete skip;};
	void resetskip()
	{
		/*if(skip!=NULL)*/delete skip;
		skip = new Skip();
		skipnow=skip;
		skipnum=0;
	};
	void setskip(ULONG s,ULONG e){skipnow->setstart(s);skipnow->setend(e);
		skipnow=new Skip(*skipnow);
		skipnum++;
	};
	Skip *getskip(ULONG num){Skip* n=skip;num=min(num,skipnum);if(num>0)for(ULONG i=0;i<num;i++)n=n->getnext();return n;};
	ULONG getskipnum(){return skipnum;};
	Skip *getskipnow(){return skipnow;};
	ULONG getskipnumnow(){return skipnumnow;};
	void setskipnumnownext(){skipnumnow=min(skipnumnow+1,skipnum);skipnow=getskip(skipnumnow);};
	ULONG setskipnumnowbypos(ULONG posnow){for (ULONG i=0;i<skipnum;i++) if(*(getskip(i)->getstart())>posnow) break;skipnumnow=i;skipnow=getskip(i);return i;};
	void setloaded(BOOL f){loaded = f;};
	void setloaded(){loaded = TRUE;};
	void setrecorded(BOOL f){recorded = f;};
	void setrecorded(){recorded = TRUE;};
	BOOL getrecorded(){return recorded;};
	void setpositionnow(ULONG n){positionnow=n;};
	ULONG &getpositionnow(){return positionnow;};
	void setended(BOOL f){ended = f;};
	void setended(){ended = TRUE;};
	BOOL getended(){return ended;};
	void setposition(ULONG d){position =d;};
	ULONG &getposition(){return position;};
	void setboost(float le){lastboost=boost;boost=max(min(le,levelmax),-levelmax);};
	float &getboost(){return boost;};
	float &getlastboost(){return lastboost;};
	void setPan(float pa){lastpan=pan;pan=max(min(pa,panmax),-panmax);};
	void resetPan(){setPan(panCenter);};
	float &getPan(){return pan;};
	float &getlastPan(){return lastpan;};
	BOOL getloaded(){return loaded;};
	void setplaying(BOOL f){playing = f;};
	void setplaying(){playing = TRUE;};
	BOOL getplaying(){return playing;};
	void effectopen(int num);
	void effectOn(ULONG pos);
	void off(){setplaying(FALSE);};
	char *getName(){return name;};
	istream& read( unsigned char * buffer, int size) {return in.read(buffer, size);};
	void setName(char *n){sprintf(name,"%s",n);};
	BOOL reopensound(){return reopensound(NULL,headersize);};
	BOOL reopensound(char *head,DWORD size){setpositionnow(0);setloaded();if(head==NULL)head=header;return ::reopensound(name,in,header,size);};
	BOOL reopensound(char *newname,char *head,DWORD size){setName(newname);return reopensound(header,size);};
};

class WaveTrack:public SoundBase
{
public:
};


#endif _wavetrack